SystemOrganization addCategory: #SqueakSVNPlugins!

SimpleButtonMorph subclass: #BuildButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!BuildButton class methodsFor: 'as yet unclassified' stamp: 'rkrk 4/4/2008 18:58'!
makeWinBuildButton

	"self makeWinBuildButton"
	| btn |
	btn := self newWithLabel: 'SqueakSVNBauen'.
	btn
		actionSelector: #callBuildBat;
		target: btn;
		openInWorld.! !

!BuildButton methodsFor: 'as yet unclassified' stamp: 'rkrk 4/4/2008 18:57'!
callBuildBat

	OSProcess command: 'buildSqueakSVNPlugin.bat'! !

SmartSyntaxInterpreterPlugin subclass: #SqueakSVNPlugin
	instanceVariableNames: 'pool ctx callbackBatonOop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakSVNPlugins'!

!SqueakSVNPlugin class methodsFor: 'translation' stamp: 'rkrk 4/3/2008 13:17'!
declareCVarsIn: cg

	super declareCVarsIn: cg.

	self cCode: ''.
	cg
		var: 'pool' 		declareC: 'apr_pool_t *pool';
		var: 'ctx' 		declareC: 'svn_client_ctx_t *ctx'.
				
	cg
		addHeaderFile: '"svn_string.h"';
		addHeaderFile: '"svn_client.h"';
		addHeaderFile: '"svn_cmdline.h"';
		addHeaderFile: '"svn_wc.h"';
		addHeaderFile: '"svn_pools.h"
#define STRSIZE 1024'.	"Another way how to use define?"! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'rt 4/2/2008 14:30'!
authenticateLocalPool: localPool AndLocalContext: localCtx 

	self
		var: #localPool type: 'apr_pool_t**';
		var: #localCtx type: 'svn_client_ctx_t**'.
		
	self writeTextToOutputFile: 'start copy authentication baton from global pool'.
	self cCode: '(*localCtx)->auth_baton = ctx->auth_baton'.
	self writeTextToOutputFile: 'end copy authentication baton from global pool'.! !

!SqueakSVNPlugin methodsFor: 'as yet unclassified' stamp: 'pe 3/27/2008 14:52'!
authenticateWithName: username andPassword: password

	| cUsername cPassword |
	self export:true.
	self
		var: #cUsername	declareC: 'char* cUsername';
		var: #cPassword	declareC: 'char* cPassword'.
	self primitive: 'authenticateWithNameAndPassword' parameters: #(String String).
	
	self writeTextToOutputFile: 'start authentication'.
	cUsername := self cStringFromOop: username.
	cPassword := self cStringFromOop: password.
	self cCode: 'authenticate( &pool, &ctx, username, password )'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 21:46'!
cStringAllocatedOnHeapFromOop: aString
"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!Deprecated!!!!!!
Please do not allocate space on the heap anymore. Use Squeak objects passed by the image instead.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"

	"Copied from OSProcessPlugin
	Free the result !!!!!!"

	"Answer a new null-terminated C string copied from aString. The C string
	is allocated from the C runtime heap. See transientCStringFromString for
	a version which allocates from object memory.
	Caution: This may invoke the garbage collector."

	| len sPtr cString |
	self returnTypeC: 'char *'.
	self var: 'sPtr' declareC: 'char *sPtr'.
	self var: 'cString' declareC: 'char *cString'.
	self var: 'len' declareC: 'size_t len'.
	sPtr := interpreterProxy arrayValueOf: aString.
	len := interpreterProxy sizeOfSTArrayFromCPrimitive: sPtr.
	cString := self callocWrapper: len + 1 size: 1.			"Space for a null terminated C string."
	self
		cCode: '(char *) strncpy (cString, sPtr, len)';	"Copy the string."
		cCode: 'cString[len] = ''\0'''.	"Terminate with null"
	^ cString! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 10:37'!
cStringFromOop: stringOop

	| stringPtr |
	self returnTypeC: 'const char *'.
	self var: #stringPtr declareC: 'char* stringPtr'.
	
	stringPtr :=  interpreterProxy arrayValueOf: stringOop.
	stringPtr at: (interpreterProxy stSizeOf: stringOop) put: (self cCode: '''\0''').
	^ stringPtr! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rkrk 3/13/2008 22:51'!
callocWrapper: count size: objectSize
	"Copied from OSProcessPlugin"
	"Using malloc() and calloc() is something I would like to avoid, since it is
	likely to cause problems some time in the future if somebody redesigns
	object memory allocation. This wrapper just makes it easy to find senders
	of calloc() in my code. -dtl"

	self returnTypeC: 'void *'.
	^ self cCode: 'calloc(count, objectSize)'! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'rt 4/8/2008 23:52'!
commitCallbackToSetMessage: logMessage
	AndMessageFile: messageFile
	FromItems: commitItems
	AndMessageBaton: batonWithMessage
	WithPool: callbackPool
	
	self
		var: #logMessage 			type: 'const char **';
		var: #messageFile 			type: 'const char **'; "a path"
		var: #commitItems 			type: 'const apr_array_header_t *';
		var: #batonWithMessage 	type: 'void *';
		var: #callbackPool 			type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	"does the same like the callback in the wrapper"

	self cCode: '*logMessage = (const char *) batonWithMessage'.
	self cCode: '*messageFile = NULL'.

	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rt 4/1/2008 13:37'!
commitLogCountingCallbackWithBaton: baton
	ForPaths: changedPaths
	AtRevision: revision
	ForAuthor: author
	AndDate: date
	AndWithMessage: message
	AllAllocatedInPool: callbackPool

	| num |
	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton				type: 'void *';
		var: #changedPaths		type: 'apr_hash_t *';
		var: #revision			type: 'svn_revnum_t';
		var: #author			type: 'const char *';
		var: #date				type: 'const char *';
		var: #message			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *';
		var: #num				declareC: 'int* num'.

	self writeTextToOutputFile: 'commitLogCountingCallback entered'.
	num := self cCode: '(int*)baton'.
	self cCode: '*num = *num + 1'.
	^ self cCode: 'SVN_NO_ERROR'.! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'rt 4/7/2008 18:30'!
computeStatusForEntryInBaton: baton
	WithPath: path
	Dirent: dirent
	Lock: lock
	AbsPath: absPath
	AndPool: callbackPool
	
	| hashFromBaton newValue |
	self
		var: #baton 			type: 'void *';
		var: #path 				type: 'const char *';
		var: #dirent 			type: 'const svn_dirent_t *';
		var: #lock 				type: 'const svn_lock_t *';
		var: #absPath 			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *';
		var: #hashFromBaton	declareC: 'apr_hash_t *hashFromBaton';
		var: #newValue			declareC: 'svn_dirent_t *newValue'.
	self returnTypeC: 'svn_error_t *'.
	
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Entered'.
	self writeTextToOutputFile: path.
	
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Getting'.
	hashFromBaton := self cCode: '*((apr_hash_t**)baton)'.
	(self cCode: '(int) apr_hash_get( hashFromBaton , path , APR_HASH_KEY_STRING )')
		ifFalse: [^ self cCode: 'SVN_NO_ERROR'].
		
	self writeTextToOutputFile: '#computeStatusForEntryInBaton: Setting'.
	newValue := self cCode: 'svn_dirent_dup( dirent, apr_hash_pool_get (hashFromBaton) ) '.
	(self cCode: 'apr_hash_set(
		hashFromBaton,
		(void*)path,
		APR_HASH_KEY_STRING,
		(void*) newValue)').
	(self cCode: 'dirent->kind == svn_node_dir')
		ifTrue: [self writeTextToOutputFile: 'could be a project']
		ifFalse: [self writeTextToOutputFile: 'no project with this name'].
	
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 11:14'!
convertCStringToOop: aCString
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| len newString |
	self var: 'aCString' type: 'const char *'.
	len := self strlen: aCString.
	"self convertToOopCString: aCString ofSize: len."
	newString := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.
	self st: (interpreterProxy arrayValueOf: newString)
		rn: aCString
		cpy: len. "(char *)strncpy()"
	^ newString! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 11:15'!
convertToOopCString: cString ofSize: len
	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| stringOop |
	self
		var: #cString type: 'const char *';
		var: #len 	type: 'size_t'.
	
	"self
		writeTextToOutputFile: 'convertCStringOfSize:toOop:. Copy String:';
		writeTextToOutputFile: cString;
		writeTextToOutputFile: 'convertCStringOfSize:toOop: of size:';
		writeIntToOutputFile: (self strlen: cString);
		writeTextToOutputFile: 'convertCStringOfSize:toOop: to size:';
		writeIntToOutputFile: len."
	
	stringOop := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: len.

	0 to: len - 1 do: [:i |
		self print: '%c\n' f: (cString at: i).
		(self cCoerce: (interpreterProxy arrayValueOf: stringOop) to: 'char *') at: i put: (cString at: i)
		"self me: ((interpreterProxy arrayValueOf: stringOop) at: i) mc: (cString at: i) py: (self cCode: 'sizeOf(char)')"].
	(self cCoerce: (interpreterProxy arrayValueOf: stringOop) to: 'char *') at: len put: (self cCode: '''\0''').
	"0 to: len - 1 do: [:i |
		stringPtr at: len put: (cString at: i)]."
	"stringPtr at: len put: (self cCode: '''\0''')."
	"self myStr: (interpreterProxy arrayValueOf: newString) n: len cpy: cString."
	self
		writeTextToOutputFile: 'convertCStringOfSize:toOop: stringOop';
		writeTextToOutputFile:  (interpreterProxy arrayValueOf: stringOop);
		writeTextToOutputFile: 'convertCStringOfSize:toOop: Size';
		writeIntToOutputFile: (self strlen: (interpreterProxy arrayValueOf: stringOop)).
		
	^ stringOop! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/24/2008 10:54'!
copyCString: cString toOopString: oopString

	| cStrLength oopStrLength |
	self returnTypeC: 'void'.
	self
		var: #cString 		type: 'char*';
		var: #cStrLength 		declareC: 'size_t cStrLength';
		var: #oopStrLength 	declareC: 'size_t oopStrLength'.
	
	self
		writeTextToOutputFile: 'copyCString:toOopString: entered';
		writeTextToOutputFile: cString.
	
	cStrLength := self strlen: cString.
	oopStrLength := interpreterProxy stSizeOf: oopString.
	
	(oopStrLength < cStrLength)
		ifTrue: [self
				writeTextToOutputFile: 'Tried to copy a cString to an oopString';
				writeTextToOutputFile: cString;
				writeTextToOutputFile: 'Attempt failed because the cString is longer than the oopString'.
			interpreterProxy success: false].
	
	self
		st: (interpreterProxy arrayValueOf: oopString)
		rn: cString
		cpy: cStrLength.

	"interpreterProxy storePointer: cStrLength ofObject: oopString withValue: (self cCode: '''\0''')."! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rkrk 3/25/2008 23:24'!
copyKeyAndValueOfAprHashIndex: hi in: arrayOop at: i
	
	|  propkey key propval value keyLen newCString |
	self
		var: #hi 			type: 'apr_hash_index_t *';
		var: #arrayOop  	type: 'sqInt';
		var: #i 			type: 'int';
		var: #key 		declareC: 'const void *key';
		var: #keyLen 		declareC: 'apr_ssize_t keyLen';
		var: #value 		declareC: 'void *value';
		var: #propkey 	declareC: 'const char *propkey';
		var:  #propval	declareC: 'svn_string_t *propval';
		var: #newCString  declareC: 'const char *newCString'.
		
	self cCode: 'apr_hash_this(hi, &key, &keyLen, &value)'.
	propkey := self cCoerce: key to: 'const char *'.
	propval := self cCoerce: value to: 'svn_string_t *'.

	self writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: ---------------------BEGIN------------------------'.
	interpreterProxy
		storePointer: i
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: propkey
			ofSize: keyLen).
	"interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: i ofObject: arrayOop)
	goes beyond the size of the char* in newSqueakString. Is this a problem?"
	interpreterProxy
		storePointer: i + 1
		ofObject: arrayOop
		withValue: (self
			convertToOopCString: (self cCode: 'propval->data')
			ofSize: (self cCode: 'propval->len')).
	
	"for debug output only"
	newCString := interpreterProxy arrayValueOf: (interpreterProxy
							fetchPointer: i
							ofObject: arrayOop).

	"self
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at:';
		writeTextToOutputFile: newCString;
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: newCString);
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: keyLen."
		"writeTextToOutputFile: (interpreterProxy arrayValueOf: (arrayPtr at: i+1));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- size:';
		writeIntToOutputFile: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i +1)));
		writeTextToOutputFile: 'copyKeyAndValueOfAprHashIndex:in:at: -- expected size:';
		writeIntToOutputFile: (self cCode: 'propval->len')."

	"description: '#convertCStringOfSize:toOop: has failed'."
	"self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i))) = keyLen.
	self assert: (self strlen: (interpreterProxy arrayValueOf: (arrayPtr at: i + 1))) = (self cCode: 'propval->len')."! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/21/2008 01:00'!
copyOopString: oopString toCString: cString ofLength: cStringLength

	self returnTypeC: 'void'.
	self var: cString type: 'char*'.
	
	((interpreterProxy stSizeOf: oopString) > cStringLength)
		ifTrue: [self
				writeTextToOutputFile: 'Tried to copy an oopString into a cStrign';
				writeTextToOutputFile: (interpreterProxy arrayValueOf: oopString);
				writeTextToOutputFile: 'Attempt failed because the oopString is longer than the cString'.
			interpreterProxy success: false].
	self
		st: cString
		rn: (interpreterProxy arrayValueOf: oopString)
		cpy: (interpreterProxy stSizeOf: oopString).
	cString at: (interpreterProxy stSizeOf: oopString) put: (self cCode: '''\0''').! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/8/2008 23:45'!
dummyCallbackWithBaton: baton Path: path Info: info Pool: callbackPool
	"should not need it any longer"

	self
		var: #baton 		type: 'void*';
		var: #path 			type: 'const char*';
		var: #info 			type: 'const svn_info_t*';
		var: #callbackPool 	type: 'apr_pool_t*'.
	self returnTypeC: 'svn_error_t*'.
	self writeTextToOutputFile: '#dummyCallback: info requested'.
	^self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/6/2008 20:31'!
forRequiresAuthRequestPreparePool: localPool
	AndCtx: localCtx
	StoreInvocationtNotificationIn: invocationNotif
	
	| providers provider |
	self
		var: #localPool 			type: 'apr_pool_t**';
		var: #localCtx 			type: 'svn_client_ctx_t**';
		var: #invocationNotif 	type: 'int*';
		var: #providers			declareC: 'apr_array_header_t *providers';
		var: #provider			declareC: 'svn_auth_provider_object_t *provider'.
					
	providers := self cCode: 'apr_array_make (*localPool, 2, sizeof (svn_auth_provider_object_t *))'.
		
	"password needed"
	self cCode: 'svn_auth_get_simple_prompt_provider (
		&provider,
		invocationCallbackForCredentialNotificationBatonRealmUsernameMaySaveIndicatorAndPool,
		(void*) invocationNotif,
		0, *localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"username needed"
	self cCode: 'svn_auth_get_username_prompt_provider (
		&provider,
		invocationCallbackForCredentialNotificationBatonRealmMaySaveIndicatorAndPool,
		(void*) invocationNotif,
		0, *localPool)'.
	self cCode: 'APR_ARRAY_PUSH (providers, svn_auth_provider_object_t *) = provider'.
	
	"Register the auth-providers into the context's auth_baton."
	self cCode: 'svn_auth_open (&(*localCtx)->auth_baton, providers, *localPool)'.! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'rt 4/2/2008 14:25'!
freeLocalPool: localPool 

	self var: localPool type: 'apr_pool_t**'.
	self writeTextToOutputFile: 'free a local pool'.
	self freeMemory: localPool.
	self writeTextToOutputFile: 'local pool freed'.! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rt 4/3/2008 15:19'!
getCommitLogCallbackWithBaton: baton
	ForPaths: changedPaths
	AtRevision: revision
	ForAuthor: author
	AndDate: date
	AndWithMessage: message
	AllAllocatedInPool: callbackPool
	
	| revisionString authorName dateString logMessage hashPool |

	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton				type: 'void *';
		var: #changedPaths		type: 'apr_hash_t *';
		var: #revision			type: 'svn_revnum_t';
		var: #author			type: 'const char *';
		var: #date				type: 'const char *';
		var: #message			type: 'const char *';
		var: #callbackPool 		type: 'apr_pool_t *'; "use the hash pool !!!!!!"
		var: #revisionString	declareC: 'char *revisionString';
		var: #authorName		declareC: 'char *authorName';
		var: #dateString		declareC: 'char *dateString';
		var: #logMessage 		declareC: 'char *logMessage';
		var: #hashPool			declareC: 'apr_pool_t *hashPool'.

	self writeTextToOutputFile: 'getCommitLogCallback: Entered'.
	hashPool := self cCode: '(*(apr_array_header_t**)baton)->pool'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy revision'.
	revisionString := self cCode: 'apr_psprintf(hashPool, "%ld", revision)'.
	self writeTextToOutputFile: revisionString.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, revisionString)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy author'.
	author
		ifTrue: [authorName := author]
		ifFalse: [authorName :=  self cCode: '"no author"'].
	self writeTextToOutputFile: authorName.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, authorName)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy date'.
	date
		ifTrue: [dateString := date]
		ifFalse: [dateString :=  self cCode: '"no date"'].
	self writeTextToOutputFile: dateString.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, dateString)'.
	
	self writeTextToOutputFile: 'getCommitLogCallback: Copy message'.
	message
		ifTrue: [logMessage := message]
		ifFalse: [logMessage := self cCode: '"no message"'].
	self writeTextToOutputFile: logMessage.
	self cCode: 'APR_ARRAY_PUSH ( *(apr_array_header_t**)baton, char* ) = apr_pstrdup(hashPool, logMessage)'.

	^ self cCode: 'SVN_NO_ERROR'.! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'rt 4/2/2008 14:38'!
initialiseLocalPool: localPool AndLocalContext: localCtx 

	self
		var: #localPool 	type: 'apr_pool_t**';
		var: #localCtx 	type: 'svn_client_ctx_t**'.
			
	self writeTextToOutputFile: 'initialize local pool and local client context'.
	self cCode: 'initializeWithParentPool(&pool, localPool, localCtx)'.
	self writeTextToOutputFile: 'local pool and local client initialised'.! !

!SqueakSVNPlugin methodsFor: 'initialize' stamp: 'pe 3/27/2008 14:16'!
initialiseModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  initialize of SqueakSVNPlugin'.
	self
		cCode: 'initialize(&pool, &ctx)';
		cCode: 'authenticate(&pool, &ctx, "DEFAULTUSER", "PASSWORD")'.
	self writeTextToOutputFile: 'Initialize  of SqueakSVNPlugin complete'.
	^ true
! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/6/2008 20:28'!
invocationCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #username 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	self writeTextToOutputFile: '#invocationCallback: username request'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->may_save = FALSE';
		cCode: '*((int*)baton) = TRUE'.
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/6/2008 20:26'!
invocationCallbackForCredential: cred
	NotificationBaton: baton
	Realm: realm
	Username: username
	MaySaveIndicator: maySave
	AndPool: localPool

	self
		var: #cred 			type: 'svn_auth_cred_simple_t **';
		var: #baton 		type: 'void *';
		var: #realm 		type: 'const char *';
		var: #username 	type: 'const char *';
		var: #maySave 		type: 'svn_boolean_t';
		var: #localPool		type: 'apr_pool_t *'.
	self returnTypeC: 'svn_error_t *'.
	self writeTextToOutputFile: '#invocationCallback: password request'.
	
	self
		cCode: '(*cred) = apr_pcalloc(localPool, sizeof(svn_auth_cred_simple_t*))';
		cCode: '(*cred)->username = ""';
		cCode: '(*cred)->password = ""';
		cCode: '(*cred)->may_save = FALSE';
		cCode: '*((int*)baton) = TRUE'.
	^ self cCode: 'SVN_NO_ERROR'! !

!SqueakSVNPlugin methodsFor: 'string helper' stamp: 'rkrk 3/20/2008 01:35'!
myStr: destination n: size cpy: source

	"Answer a new String copied from a null-terminated C string.
	Caution: This may invoke the garbage collector."

	| newString |
	self
		var: 'destination' type: 'char *';
		var: 'source' type: 'const char *';
		var: 'size' type: 'size_t'.
	
	self
		writeTextToOutputFile: 'myStrncpy: Copy String:';
		writeTextToOutputFile: source;
		writeTextToOutputFile: 'myStrncpy: To size';
		writeIntToOutputFile: size.
		
	0 to: size - 1 do: [:i |
		destination at: i put: (source at: i)].
	destination at: size put: (self cCode: '''\0''').
	self
		writeTextToOutputFile: 'myStrncpy: destination';
		writeTextToOutputFile:  destination;
		writeTextToOutputFile: 'myStrncpy: Size';
		writeIntToOutputFile: (self strlen: (destination)).
		
	^ newString! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'pe 3/27/2008 15:54'!
onlyATest

	| result |
	self export: true.
	self var: #result declareC: 'char *result'.
	result := self cCode: 'test(&pool, &ctx)'.
	interpreterProxy
		pop: 1
		thenPush: (self convertCStringToOop: result).! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 14:29'!
printStatusKinds

	self writeTextToOutputFile: 'All status:'.	
		
	self
		writeTextToOutputFile: 'svn_wc_status_none';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_none').
	
	self
		writeTextToOutputFile: 'svn_wc_status_normal:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_normal').
	self
		writeTextToOutputFile: 'svn_wc_status_added:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_added').
	self
		writeTextToOutputFile: 'svn_wc_status_missing:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_missing').
	self
		writeTextToOutputFile: 'svn_wc_status_incomplete:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_incomplete').
	self
		writeTextToOutputFile: 'svn_wc_status_deleted:';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_deleted').
	self
		writeTextToOutputFile: 'svn_wc_status_replaced';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_replaced').
	self
		writeTextToOutputFile: 'svn_wc_status_modified';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_modified').
	self
		writeTextToOutputFile: 'svn_wc_status_merged';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_merged').
	self
		writeTextToOutputFile: 'svn_wc_status_conflicted';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_conflicted').
	self
		writeTextToOutputFile: 'svn_wc_status_obstructed';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_obstructed').
	self
		writeTextToOutputFile: 'svn_wc_status_ignored';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_ignored').
	self
		writeTextToOutputFile: 'svn_wc_status_external';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_external').
	self
		writeTextToOutputFile: 'svn_wc_status_unversioned';
		writeIntToOutputFile: (self cCode: 'svn_wc_status_unversioned').! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/21/2008 03:30'!
putAprDate: date in: arrayOop at: index

	| dateString|
	self
		var: #index type: 'int';
		var: #date type: 'apr_time_t';
		var: #dateString declareC: 'char dateString[APR_CTIME_LEN] '.

	date = nil ifTrue: [^ nil].
	self cCode: 'apr_ctime(dateString, date)'.
	self putString: dateString in: arrayOop at: index.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/24/2008 10:52'!
putRevision: revision in: arrayOop at: index

	self
		var: #index type: 'int';
		var: #revision type: 'svn_revnum_t'.

	revision = nil ifTrue: [^ nil].
	self writeIntToOutputFile: revision.
	
	interpreterProxy
		storePointer: index
		ofObject: arrayOop
		withValue: (interpreterProxy integerObjectOf: revision).! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/26/2008 00:36'!
putSchedule: schedule in: arrayOop at: index

	self
		var: #index type: 'int';
		var: #schedule type: 'svn_wc_schedule_t'.

	"schedule = nil ifTrue: [^ nil]."
	schedule = (self cCode: 'svn_wc_schedule_normal')  	ifTrue: [self putString: 'normal' in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_add' )		ifTrue: [self putString: 'add' 	in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_delete' )	ifTrue: [self putString: 'delete' 	in: arrayOop at: index.].
	schedule = (self cCode: 'svn_wc_schedule_replace' )	ifTrue: [self putString: 'replace' in: arrayOop at: index.].! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 13:25'!
putStatus: statusKind in: arrayOop at: index

	self
		var: #index 	type: 'int';
		var: #statusKind 	type: 'int'.

	interpreterProxy
		storePointer: index
		ofObject: arrayOop
		withValue: (interpreterProxy integerObjectOf: statusKind).! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/24/2008 10:51'!
putString: cstring in: arrayOop at: index

	| stringOop |
	self
		var: #cstring type: 'const char *';
		var: #index type: 'int'.
	self	var: #stringOop declareC: 'sqInt stringOop'.

	cstring = nil ifTrue: [^ nil].
	self
		copyCString: cstring
		toOopString: (interpreterProxy
			fetchPointer: index
			ofObject: arrayOop).! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/9/2008 00:05'!
repositoryAtUrl: url Exists: boolExists AndNeedsAuthentication: boolNeedsAuth

	| localPool localCtx err revision uuid |
	self
		var: #url 				type: 'char *';
		var: #boolExists 		type: 'int *';
		var: #boolNeedsAuth 	type: 'int *';
		var: #err				declareC: 'svn_error_t *err';
		var: #revision 			declareC: 'svn_opt_revision_t revision';
		var: #uuid 				declareC: 'char *uuid';
		var: #localPool			declareC: 'apr_pool_t *localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t *localCtx'.
	self returnTypeC: 'int'.
					
	self writeTextToOutputFile: '#repositoryAtUrl:Exists:AndNeedsAuthentication: Entered'.
	self
		cCode: '*boolExists = FALSE';
		cCode: '*boolNeedsAuth = FALSE'.
		
	(self cCode: 'svn_path_is_url(url)')
		ifFalse: [^ self cCode: '1'].
	self
		initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	"prepare authentication system"
	self
		forRequiresAuthRequestPreparePool: (self cCode: '&localPool')
		AndCtx: (self cCode: '&localCtx')
		StoreInvocationtNotificationIn: boolNeedsAuth.
		
	"self cCode: 'revision.kind = svn_opt_revision_head'.
	err := self cCode: 'svn_client_info (
		url,
		&revision,
		&revision,
		dummyCallbackWithBatonPathInfoPool,
		NULL,
		FALSE,
		localCtx, localPool)'."
	err := self cCode: 'svn_client_uuid_from_url (
		&uuid,
		url,
		localCtx, localPool)'.
	(err not or: [self cCode: '*boolNeedsAuth == TRUE'])
		ifTrue: [self cCode: '*boolExists = TRUE'].
	
	self writeTextToOutputFile: '#repositoryAtUrl:Exists:AndNeedsAuthentication: Exit'.
	self freeLocalPool: (self cCode: '&localPool').
	^ self cCode: '1'! !

!SqueakSVNPlugin methodsFor: 'shutdown' stamp: 'rkrk 3/17/2008 04:06'!
shutdownModule

	self export: true.
	self writeTextToOutputFile: 'Beginning  shutdown of SqueakSVNPlugin'.
	"Free the apr memory pool"
	self cCode: 'freeMemory(&pool)'.
	
	self writeTextToOutputFile: 'Shutdown of SqueakSVNPlugin complete'.
	^ true! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/17/2008 20:46'!
sizeForSvnInfoArray

	^ 12! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/2/2008 17:54'!
squeakArrayFromAprHash: aprHash

	| arrayOop i hi arraySize localPool localCtx |
	self
		var: #aprHash 		type: 'apr_hash_t *';
		var: #hi			declareC:  'apr_hash_index_t *hi';
		var: #arraySize 	declareC: 'size_t arraySize';
		var: #i 				declareC: 'int i';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx'.

	self writeTextToOutputFile: '#squeakArrayFromAprHash: Properties read. Copying...'.
	"We need only a pool !!!!!!"
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self writeTextToOutputFile: '#squeakArrayFromAprHash: pool initialized'.
	
	"Store key and values in an array. Therefore this array
	must have twice the size of the hash table"
	self writeIntToOutputFile: (self cCode: '2 * apr_hash_count(aprHash)').
	self writeTextToOutputFile: '#squeakArrayFromAprHash: int printed'.
	arraySize := self cCode: '2 * apr_hash_count(aprHash)'.
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: arraySize.
		
	self writeTextToOutputFile: '#squeakArrayFromAprHash: Start copying properties'.
	
	i := 0.
	hi := self cCode: 'apr_hash_first(localPool, aprHash)'.
	[hi] whileTrue: [
		self
			copyKeyAndValueOfAprHashIndex: hi
			in: arrayOop
			at: i.
		i := i + 2. "Store both key and value in array"
		hi := self cCode: 'apr_hash_next(hi)'].
	
	self writeTextToOutputFile: '#squeakArrayFromAprHash: Finished copying properties'.
	self freeLocalPool: (self cCode: '&localPool').
	^ arrayOop! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/12/2008 13:25'!
stringTest01

	| oop ptr aString |

	self export: true.
	self var: #aString declareC: 'char *aString'.
	self var: #ptr declareC: 'char *ptr'.
	self cCode: 'aString = "hallo welt"'.
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: 20.
	ptr := interpreterProxy firstIndexableField: oop.
	0 to: 12"size"-1 do:[:i|
		ptr at: i put: (aString at: i)].
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'old' stamp: 'rkrk 3/20/2008 04:33'!
stringTest02

	| oop ptr aString |

	self export: true.
	self
		"var: #aString declareC: 'char aString[] = /Users/robertkrahn/squeak/squeakSVN/images/svnTests/SVNAwareTestDirectory_71/workingCopy';"
		var: #aString declareC: 'char aString[] = "Haloo"';
		var: #ptr 	declareC: 'char *ptr'.
	
	aString at: 3 put: (self cCode: '''\0''').
	self	writeIntToOutputFile: (self strlen: aString).
	oop := interpreterProxy
		instantiateClass: interpreterProxy classString
		indexableSize: (self strlen: aString).
	0 to: (self strlen: aString) - 1 do: [:i |
		self print: '%c\n' f: (aString at: i).
		(self cCoerce: (interpreterProxy arrayValueOf: oop) to: 'char *') at: i put: (aString at: i)].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: oop).
	interpreterProxy
		pop: 1
		thenPush: oop.! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'pe 4/10/2008 13:01'!
svnAdd: targetOop 
	| err target stringPtr localPool localCtx |
	self export: true.
	self
		var: #target declareC: 'const char target[STRSIZE]';
		var: #err declareC: 'svn_error_t *err';
		var: #localPool declareC: 'apr_pool_t* localPool';
		var: #localCtx declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnAdd'
		parameters: #(#Oop ).
	self writeTextToOutputFile: '#svnAdd: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self 
		writeTextToOutputFile: '#svnAdd: copyOopStringToCStringOfLength'.
	self 
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	self writeTextToOutputFile: '#svnAdd: svn_client_add3'.
	err := self 
				cCode: 'svn_client_add3(
			target,
			TRUE,		// recurse
			FALSE,		// force, error on already versioned items
			TRUE,		// no_ignore, we do not use ignore pattern here 
			localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	self writeTextToOutputFile: '#svnAdd: freeLocalPool'.
	self freeLocalPool: (self cCode: '&localPool').
	^ targetOop! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/2/2008 16:05'!
svnAddProperty: propertyOop WithValue:valueOop To: targetOop

	| property value target localPool localCtx |
	self export: true.
	self
		var: #property 	declareC: 'char property[STRSIZE]';
		var: #value 	declareC: 'char value[STRSIZE]';
		var: #target 	declareC: 'char target[STRSIZE]';
		var: #localPool	declareC: 'apr_pool_t* localPool';
		var: #localCtx	declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnAddPropertyWithValueTo' parameters: #(Oop Oop Oop).
	
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Parse property, value and target'.
	self
		copyOopString: propertyOop
		toCString: property
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: property.
	self
		copyOopString: valueOop
		toCString: value
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: value.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Call subversion'.
	self cCode: 'addPropertyAndValueToTarget (&localPool, &localCtx, property, value, target)'.
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnAddProperty:WithValue:To: Exit'.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/20/2008 16:11'!
svnAlternativeGetHeadRevision: targetOop

	| resultArray arrayPtr revision target truepath err pegRevision|
	self export: true.
	self
		var: #arrayPtr 		declareC: 'sqInt* arrayPtr';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #pegRevision 	declareC: 'svn_opt_revision_t pegRevision';
		var: #target 			declareC: 'const char *target';
		var: #truepath 		declareC: 'char *truepath';
		var: #err 			declareC: 'svn_error_t *err'.
	self primitive: 'svnAlternativeGetHeadRevision' parameters: #(Oop).

	self writeTextToOutputFile: '#svnAlternativeGetHeadRevision: Entered'.
	
	target := interpreterProxy arrayValueOf: targetOop.
	
	resultArray := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: self sizeForSvnInfoArray.
	arrayPtr := interpreterProxy firstIndexableField: resultArray.
	
	arrayPtr. revision. target. truepath. pegRevision.
	
	self cCode: 'svn_opt_parse_path(&pegRevision, &truepath, target, pool)'.
	self cCode: 'pegRevision.kind = svn_opt_revision_unspecified'.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	"self cCode: 'revision.value.number = 7'."
	err := self cCode: 'svn_client_info (
		truepath,
		&pegRevision, 					/* peg-revision */
		&revision, 						/* revision ???? */
		svnInfoCbBatonTargetInfoPool,		/* callback */
		(void*) &arrayPtr, 				/* baton */
		FALSE, 							/* no recurse */
		ctx, pool)'.
	err ifTrue: [self handleError: err].
	
	^ resultArray! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'rt 4/2/2008 16:15'!
svnCheckoutHeadRevisionFrom: aURLOop to: aPathOop

	| url path localPool localCtx |
	self export: true.
	self
		var: #url 		declareC: 'char url[STRSIZE]';
		var: #path 		declareC: 'char path[STRSIZE]';
		var: #localPool	declareC: 'apr_pool_t* localPool';
		var: #localCtx	declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnCheckoutHeadRevisionFromTo' parameters: #(Oop Oop ).
	
	self writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	self writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Parse url and path'.
	self 
		copyOopString: aURLOop
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	self 
		copyOopString: aPathOop
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: path.
	
	self writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Call subversion'.
	self cCode: 'checkoutHeadRevisionFormTo(&localPool, &localCtx, url, path)'.
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCheckoutHeadRevisionFrom:to: Exit'.! !

!SqueakSVNPlugin methodsFor: 'svn checkout' stamp: 'pe 4/10/2008 13:45'!
svnCheckoutRevisionByNumber: aNumberOop from: aURLOop to: aPathOop 
	| err revisionNumber url path revision localPool localCtx |
	self export: true.
	self
		var: #revisionNumber declareC: 'long int revisionNumber';
		var: #url declareC: 'char url[STRSIZE]';
		var: #path declareC: 'char path[STRSIZE]';
		var: #localPool declareC: 'apr_pool_t* localPool';
		var: #localCtx declareC: 'svn_client_ctx_t* localCtx';
		var: #revision declareC: 'svn_opt_revision_t revision';
		var: #err declareC: 'svn_error_t *err'.
	self primitive: 'svnAlternativeCheckoutRevisionByNumberFromTo'
		parameters: #(#Integer #Oop #Oop ).
	self 
		writeTextToOutputFile: '#svnAlternativeCheckoutRevisionByNumber: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool')
		AndLocalContext: (self cCode: '&localCtx').
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	self writeIntToOutputFile: revisionNumber.
	self
		cCode: 'revision.kind = svn_opt_revision_number';
		cCode: 'revision.value.number = revisionNumber'.
	self 
		copyOopString: aURLOop
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	self 
		copyOopString: aPathOop
		toCString: path
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: path.
	self 
		writeTextToOutputFile: 'svnAlternativeCheckoutRevisionByNumber: svn_client_checkout2'.
	err := self 
				cCode: 'svn_client_checkout2(
		NULL,				
		url,
		path,
		&revision,
		&revision,
		TRUE,
		FALSE,
		ctx, pool)'.
	err ifTrue: [self handleError: err].
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnAlternativeCheckoutRevisionByNumber end'! !

!SqueakSVNPlugin methodsFor: 'svn cleanup' stamp: 'rt 4/2/2008 16:19'!
svnCleanupDirectory: directory

	| dir err localPool localCtx |
	self export: true.
	self 
		var: #dir		declareC: 'char dir[STRSIZE]';
		var: #err 		declareC: 'svn_error_t *err';
		var: #localPool	declareC: 'apr_pool_t* localPool';
		var: #localCtx	declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnCleanupDirectory' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Parse directory'.
	self 
		copyOopString: directory
		toCString: dir
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: dir.
	
	self writeTextToOutputFile: '#svnCleanupDirectory: Call subversion'.
	err := self cCode: 'svn_client_cleanup(
		dir,
		localCtx,
		localPool)'.
	err ifTrue: [self handleError: err].
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCleanupDirectory: Exit'.
	^directory! !

!SqueakSVNPlugin methodsFor: 'svn commit' stamp: 'rt 4/2/2008 16:42'!
svnCommit: aOopCollectionOfOopTargets WithMessage: aOopMessage

	| targetsArray squeakStrings count cString message localPool localCtx |
	self export: true.
	self
		var: #squeakStrings 	declareC: 'char** squeakStrings';
		var: #targetsArray 		declareC: 'char** targetsArray';
		var: #cString 			declareC: 'char* cString';
		var: #message 			declareC: 'char message[STRSIZE]';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnCommitWithMessage' parameters: #(Oop Oop).
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Parse variables'.
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Parse message'.
	self 
		copyOopString: aOopMessage
		toCString: message
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: message.
	
	
	self writeTextToOutputFile: '#svnCommit:WithMessage: Call subversion'.
	self cCode: 'commit( &localPool, &localCtx, count, targetsArray, message)'.


	self cCode: 'free( targetsArray )'.
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnCommit:WithMessage: Exit'.! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'rt 4/8/2008 12:03'!
svnCreateProject: aName OnRepository: aUrl

	| projectName repositoryUrl fullUrl err commitInfo logMessage pathAprArray localCtx localPool |
	self export: true.
	self
		var: #projectName			declareC: 'char projectName[STRSIZE]';
		var: #repositoryUrl 			declareC: 'char repositoryUrl[STRSIZE]';
		var: #fullUrl 				declareC: 'char *fullUrl';
		var: #err 					declareC: 'svn_error_t *err';
		var: #commitInfo			declareC: 'svn_commit_info_t *commitInfo';
		var: #logMessage 			declareC: 'const char *logMessage';
		var: #pathAprArray		declareC: 'apr_array_header_t *pathAprArray';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx';
		var: #localPool				declareC: 'apr_pool_t *localPool'.
	self primitive: 'svnCreateProjectOnRepository' parameters: #(Oop Oop).
	
	self writeTextToOutputFile: '#svnCreateProject:OnRepository: Entered'.
	
	"parse the name and the url"
	self
		copyOopString: aName
		toCString: projectName
		ofLength: (self cCode: 'STRSIZE').
	self
		copyOopString: aUrl
		toCString: repositoryUrl
		ofLength: (self cCode: 'STRSIZE').
		
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	"compute projects full url and put it in an array (mkdir needs it)"
	fullUrl := self cCode: 'svn_path_url_add_component(repositoryUrl, projectName, localPool)'.
	self writeTextToOutputFile: fullUrl.
	pathAprArray := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (pathAprArray, char*) = fullUrl'.
	
	"create the commit information"
	logMessage := self cCode: 'apr_psprintf (localPool, "Repository: Create project named %s", projectName)'.
	self
		cCode: 'localCtx->log_msg_func2 = commitCallbackToSetMessageAndMessageFileFromItemsAndMessageBatonWithPool';
		cCode: 'localCtx->log_msg_baton2 = (void *) logMessage'.
	
	"call svn"
	err := self cCode: 'svn_client_mkdir2(
		&commitInfo,
		pathAprArray,
		localCtx,
		localPool)'.
	err
		ifTrue: [self handleError: err.
				interpreterProxy primitiveFail].! !

!SqueakSVNPlugin methodsFor: 'svn adding and deleting' stamp: 'rt 4/2/2008 16:50'!
svnDeleteTargetsFromWorkingCopy: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString localPool localCtx |
	self export: true.
	self
		var: #squeakStrings declareC: 'char** squeakStrings';
		var: #targetsArray 	declareC: 'char** targetsArray';
		var: #cString 		declareC: 'char* cString';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnDeleteTargetsFromWorkingCopy' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Parse variables'.
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Call subversion'.
	self cCode: 'deleteTargetsFromWC( &localPool, &localCtx, count, targetsArray )'.

	self cCode: 'free( targetsArray )'.
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnDeleteTargetsFromWorkingCopy: Exit'.
	^aOopCollectionOfOopTargets! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/4/2008 13:01'!
svnExistsRepositoryOnUrl: aUrl

	| url boolExists boolNeedsAuth |
	self export: true.
	self
		var: #url				declareC: 'char url[STRSIZE]';
		var: #boolExists			declareC: 'int boolExists';
		var: #boolNeedsAuth	declareC: 'int boolNeedsAuth'.
	self primitive: 'svnExistsRepositoryOnUrl' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnExistsRepositoryOnUrl: Entered'.
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self
		repositoryAtUrl: url
		Exists: (self cCode: '&boolExists')
		AndNeedsAuthentication: (self cCode: '&boolNeedsAuth').
	boolExists ifTrue: [^interpreterProxy trueObject].
	^interpreterProxy falseObject! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rt 4/2/2008 17:07'!
svnGetBlameLinesFrom: targetOop
	"returns an array like #(rev1 author1 date1 line1 ...)"
	
	| target cArray arrayOop ptr numberOfLines localPool localCtx |
	self export: true.
	self
		var: #target 			declareC: 'char target[STRSIZE]';
		var: #cArray 			declareC: 'char **cArray';
		var: #numberOfLines 	declareC: 'int numberOfLines';
		var: #ptr 				declareC: 'int *ptr';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnGetBlameLinesFrom' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	self writeTextToOutputFile: '#svnGetBlameLinesFrom: Parse target'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.

	"get the filled array"
	self cCode: 'getBlameLines(&localPool, &localCtx, target, &numberOfLines, &cArray)'.

	"Create a Squeak-Array in which the result can be returned"
	arrayOop := interpreterProxy
		instantiateClass: interpreterProxy classArray
		indexableSize: numberOfLines.
	
	"Copy the entries into the Squeak-Array and free them"
	ptr := interpreterProxy firstIndexableField: arrayOop.
	0 to: numberOfLines - 1 do: [:i |
		ptr at: i put: (self convertCStringToOop: (cArray at: i)).
		self free: (cArray at: i)].
	self free: cArray.
	
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnGetBlameLinesFrom: Exit'.
	^ arrayOop.! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rt 4/3/2008 15:17'!
svnGetCommitLogs: countOop from: targetOop to: revisionNumberOop storeInArray: resultArray
	| err revision startRevision endRevision endRevisionNumber arrayOfTheTarget arrayOfTheLogs count target localPool localCtx |
	self export: true.
	self
		var: #err					declareC: 'svn_error_t *err';
		var: #revision				declareC: 'svn_opt_revision_t revision';
		var: #startRevision			declareC: 'svn_opt_revision_t startRevision';
		var: #endRevision 			declareC: 'svn_opt_revision_t endRevision';
		var: #endRevisionNumber	declareC: 'long int endRevisionNumber';
		var: #arrayOfTheTarget		declareC: 'apr_array_header_t *arrayOfTheTarget';
		var: #arrayOfTheLogs		declareC: 'apr_array_header_t *arrayOfTheLogs';
		var: #count 				declareC: 'int count';
		var: #target 				declareC: 'char target[STRSIZE]';
		var: #localPool				declareC: 'apr_pool_t *localPool';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx'.
	self primitive: 'svnGetCommitLogsFromToStoreInArray'
		parameters: #(Integer Oop Integer Oop ).
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Setup variables'.

	self cCode: 'revision.kind = svn_opt_revision_unspecified'.	
	self cCode: 'startRevision.kind = svn_opt_revision_number'.
	self cCode: 'startRevision.value.number = 0'.	
	self cCode: 'endRevision.kind = svn_opt_revision_number'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse number of end revision:'.
	endRevisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
	self writeIntToOutputFile: endRevisionNumber.
	self cCode: 'endRevision.value.number = endRevisionNumber'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse size of result array:'.
	self writeIntToOutputFile: (interpreterProxy integerValueOf: countOop).
	count := 4* (interpreterProxy integerValueOf: countOop).
	self writeIntToOutputFile: count.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Parse the target:'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	arrayOfTheTarget := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (arrayOfTheTarget, char*) = apr_pstrdup(localPool, target)'.

	"initialize the log array"
	arrayOfTheLogs := self cCode: 'apr_array_make (localPool, 0, sizeof(char*))'.
	
	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Call subversion'.
	err := self cCode: 'svn_client_log3(
		arrayOfTheTarget,
		&revision,
		&startRevision,
		&endRevision,
		0,
		FALSE,
		FALSE,
		getCommitLogCallbackWithBatonForPathsAtRevisionForAuthorAndDateAndWithMessageAllAllocatedInPool,
		(void *) &arrayOfTheLogs,
		localCtx, localPool)'.
		
	"some error handling"
	err ifTrue: [self handleError: err].
	(self cCode: 'count !!= arrayOfTheLogs->nelts') ifTrue: [
		self writeTextToOutputFile: 'svnGetCommitLogsFromToStoreInArray: That is crash prevention!! Your array has the wrong size.'.
		self writeIntToOutputFile: count.
		self writeIntToOutputFile: (self cCode: 'arrayOfTheLogs->nelts').
		interpreterProxy primitiveFail.
		^ resultArray].
	
	self writeTextToOutputFile: 'svnGetCommitLogsFromToStoreInArray: Copy targets'.
	count ~= 0
		ifTrue: [0 to: count - 1 do: [:index |
					self writeTextToOutputFile: (self cCode: '((char**)arrayOfTheLogs->elts)[index]').
					self putString: (self cCode: '((char**)arrayOfTheLogs->elts)[index]') in: resultArray at: index]].	

	self writeTextToOutputFile: '#svnGetCommitLogsFromToStoreInArray: Return the result'.
	self freeLocalPool: (self cCode: '&localPool').
	^ resultArray! !

!SqueakSVNPlugin methodsFor: 'svn commit logs' stamp: 'rt 4/7/2008 11:19'!
svnGetCountOfCommitLogsFrom: targetOop to: revisionNumberOop 
	| err revision startRevision endRevision endRevisionNumber commitLogCount arrayOfTheTarget target localCtx localPool |
	self export: true.
	self
		var: #err					declareC: 'svn_error_t *err';
		var: #revision				declareC: 'svn_opt_revision_t revision';
		var: #startRevision			declareC: 'svn_opt_revision_t startRevision';
		var: #endRevision 			declareC: 'svn_opt_revision_t endRevision';
		var: #endRevisionNumber	declareC: 'long int endRevisionNumber';
		var: #commitLogCount		declareC: 'int commitLogCount';
		var: #arrayOfTheTarget		declareC: 'apr_array_header_t *arrayOfTheTarget';
		var: #target 	 			declareC: 'char target[STRSIZE]';
		var: #localPool				declareC: 'apr_pool_t *localPool';
		var: #localCtx				declareC: 'svn_client_ctx_t *localCtx'.
	self primitive: 'svnGetCountOfCommitLogsFromTo'
		parameters: #(Oop Integer ).
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Setup variables'.
	
	commitLogCount := 0.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.	
	self cCode: 'startRevision.kind = svn_opt_revision_number'.
	self cCode: 'startRevision.value.number = 0'.	
	self cCode: 'endRevision.kind = svn_opt_revision_number'.
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Parse number of end revision:'.
	endRevisionNumber := interpreterProxy integerValueOf: revisionNumberOop.
	self writeIntToOutputFile: endRevisionNumber.
	self cCode: 'endRevision.value.number = endRevisionNumber'.
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Parse the target:'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.
	arrayOfTheTarget := self cCode: 'apr_array_make (localPool, 1, sizeof(char*))'.
	self cCode: 'APR_ARRAY_PUSH (arrayOfTheTarget, char*) = apr_pstrdup(localPool, target)'.
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: array currupted ?'.
	self writeIntToOutputFile: (self cCode: 'arrayOfTheTarget->nelts').
	self writeTextToOutputFile: (self cCode: '((char**)arrayOfTheTarget->elts)[0]').

	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Call subversion'.
	err := self cCode: 'svn_client_log3(
		arrayOfTheTarget,
		&revision,
		&startRevision,
		&endRevision,
		0,
		FALSE,
		FALSE,
		commitLogCountingCallbackWithBatonForPathsAtRevisionForAuthorAndDateAndWithMessageAllAllocatedInPool,
		(void *) &commitLogCount,
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	
	self writeTextToOutputFile: '#svnGetCountOfCommitLogsFromTo: Return the result:'.
	self writeIntToOutputFile: commitLogCount.
	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy integerObjectOf: commitLogCount.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rt 4/2/2008 17:11'!
svnGetHeadRevision: targetOop

	| target revision localPool localCtx |
	self export: true.
	self
		var: #target 	declareC: 'char target[STRSIZE]';
		var: #revision	declareC: 'int revision';
		var: #localPool	declareC: 'apr_pool_t* localPool';
		var: #localCtx	declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnGetHeadRevision' parameters: #(Oop ).
	
	self writeTextToOutputFile: '#svnGetHeadRevision: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	self writeTextToOutputFile: '#svnGetHeadRevision: Convert target'.
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: target.

	self writeTextToOutputFile: '#svnGetHeadRevision: Call subversion'.
	self cCode: 'getHeadRevisionOf(&localPool, &localCtx, target, &revision)'.
	
	self writeTextToOutputFile: '#svnGetHeadRevision: Exit with:'.
	self writeIntToOutputFile: revision.
	^interpreterProxy integerObjectOf: revision! !

!SqueakSVNPlugin methodsFor: 'svn properties' stamp: 'rt 4/2/2008 18:00'!
svnGetPropertiesFrom: targetOop
"returns an array like #(key1 value1 key2 value2 ...)"
	
	| stringPtr err proplistItem revision truepath properties copiedOop localPool localCtx retVal |
	self export: true.
	self
		var: #err 			declareC: 'svn_error_t *err';
		var:  #revision 		declareC: 'svn_opt_revision_t revision';
		var: #truepath 		declareC: 'const char *truepath';
		var: #properties 	declareC: 'apr_array_header_t *properties';
		var: #proplistItem 	declareC: 'svn_client_proplist_item_t* proplistItem';
		var: #stringPtr 		declareC: 'char stringPtr[STRSIZE]';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx';
		var: #retVal 		declareC: 'sqInt* retVal'.

	self primitive: 'svnGetPropertiesFrom' parameters: #(Oop).
	self writeTextToOutputFile: '#svnGetPropertiesFrom: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	self writeTextToOutputFile: '#svnGetPropertiesFrom: Parse target'.
	self
		copyOopString: targetOop
		toCString: stringPtr
		ofLength: (self cCode: 'STRSIZE').
	
	self
		writeTextToOutputFile: 'Reading properties of:';
		writeTextToOutputFile: stringPtr;
		writeIntToOutputFile: (self strlen: stringPtr);
		writeIntToOutputFile: (interpreterProxy stSizeOf: targetOop).
	
	self
		cCode: 'revision.kind = svn_opt_revision_head';
		cCode: 'svn_opt_parse_path(&revision, &truepath, stringPtr, localPool)'.
	
	err := self cCode: 'svn_client_proplist2(
		&properties, 		/* result: array of svn_client_proplist_item_t */
		truepath,		/* target */
		&revision, 		/* peg-revision */
		&revision, 		/* = peg-revision ???? */
		FALSE,			/* do not recurse */
		localCtx, localPool);'.
	err ifTrue: [self handleError: err].
	
	self
		writeTextToOutputFile: 'properties->nelts';
		writeIntToOutputFile: (self cCode: 'properties->nelts').

	"return of there are no properties"
	(self cCode: 'properties->nelts') = 0 ifTrue: [^ interpreterProxy
												instantiateClass: interpreterProxy classArray
												indexableSize: 0.].
	
	"If this is done recursively there can be more than one svn_client_proplist_item_t*
	in the result. But we want the properties per target, so assume properties size = 1"
	"self assert: (self cCode: 'properties->nelts') = 1."
		(self cCode: 'properties->nelts') = 1 ifFalse: [interpreterProxy success: false].
	
	"Take the first element"
	proplistItem := self cCode: '((svn_client_proplist_item_t**) properties->elts)[0]'. 
	"self cCode: 'apr_array_pop(properties)'.	<--- Iterate over properties????"
	
	"Iterate and fill the array"
	self writeTextToOutputFile: '#svnGetPropertiesFrom: Exit'.
	retVal := self squeakArrayFromAprHash: (self cCode: 'proplistItem->prop_hash').
	self freeLocalPool: (self cCode: '&localPool').
	^ retVal! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 3/26/2008 00:35'!
svnInfoCbBaton: baton Target: target Info: info Pool: cbPool
"baton is nil. The array should be stores in callbackBatonOop"

	self returnTypeC: 'svn_error_t *'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #info type: 'const svn_info_t *';
		var: #cbPool type: 'apr_pool_t *'.
	
	self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: entered'.

	interpreterProxy success: (interpreterProxy isArray: callbackBatonOop).
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: no array...'.].
	
	self writeTextToOutputFile: (self cCode: 'info->URL').
		
	self putString:  	(self cCode: 'info->repos_root_URL') 		in: callbackBatonOop at: 0.
	"Do not consider revision kind at 1"
	self putRevision: 	(self cCode: 'info->rev') 					in: callbackBatonOop at: 2.
	self putString: 	(self cCode: 'info->repos_UUID') 			in: callbackBatonOop at: 3.
	"Do not consider revision kind at 4"
	self putRevision: 	(self cCode: 'info->last_changed_rev') 		in: callbackBatonOop at: 5.
	self putAprDate: 	(self cCode: 'info->last_changed_date') 	in: callbackBatonOop at: 6.
	self putString: 	(self cCode: 'info->last_changed_author') 	in: callbackBatonOop at: 7.
	(self cCode: 'info->has_wc_info')
		ifTrue: [self putSchedule: 	(self cCode: 'info->schedule') 	in: callbackBatonOop at: 8].
	"^ <#(repositoryUrl revision repositoryUUID lastChangedRev lastChangeDate lastChangedAuthor)>"
	^ self cCode: 'SVN_NO_ERROR'.
	

     " if (info->text_time)
        SVN_ERR(svn_cl__info_print_time(info->text_time, 
                                        _('Text Last Updated'), pool));
      
      if (info->prop_time)
        SVN_ERR(svn_cl__info_print_time(info->prop_time, 
                                        _('Properties Last Updated'), pool));
      
      if (info->checksum) 
        SVN_ERR(svn_cmdline_printf(pool, _('Checksum: %s\n'),
                                   info->checksum));
      
      if (info->conflict_old) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Previous Base File: %s\n'),
                                   svn_path_local_style(info->conflict_old,
                                                        pool)));
 
      if (info->conflict_wrk) 
        SVN_ERR(svn_cmdline_printf
                (pool, _('Conflict Previous Working File: %s\n'),
                 svn_path_local_style(info->conflict_wrk, pool)));
      
      if (info->conflict_new) 
        SVN_ERR(svn_cmdline_printf(pool,
                                   _('Conflict Current Base File: %s\n'),
                                   svn_path_local_style(info->conflict_new,
                                                        pool)));
 
      if (info->prejfile) 
        SVN_ERR(svn_cmdline_printf(pool, _('Conflict Properties File: %s\n'),
                                   svn_path_local_style(info->prejfile,
                                                        pool)));"! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 10:44'!
svnInfoForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop storeInArray: resultArrayOop

	"This can currently only be used to access the state of the element in the working copy"
	| target err truepath pegRevision revision localPool localCtx |
	self export: true.
	self
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #pegRevision 	declareC: 'svn_opt_revision_t pegRevision';
		var: #truepath 		declareC: 'char *truepath';
		var: #err 			declareC: 'svn_error_t *err';
		var: #target 	 		declareC: 'char target[STRSIZE]';
		var: #localPool		declareC: 'apr_pool_t* localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnInfoForTargetRevisionKindRevisionNumberStoreInArray' parameters: #(Oop Oop Oop Oop).
	
	self writeTextToOutputFile: '#svnInfoForTarget:storeInArray:  Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	"Prepare target string"
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	self cCode: 'svn_opt_parse_path(&pegRevision, &truepath, target, localPool)'.
	"Set the revisions for retrieving working copy informations"
	"self cCode: 'pegRevision.kind = svn_opt_revision_unspecified'."
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 1'.].
	
	"Svn call. Don't use the baton. use instVar callbackBatonOop instead'"
	callbackBatonOop := resultArrayOop.
	err := self cCode: 'svn_client_info (
		truepath,
		&pegRevision, 					/* peg-revision */
		&revision, 						/* revision ???? */
		svnInfoCbBatonTargetInfoPool,		/* callback */
		NULL, 							/* baton, we use callbackBatonOop */
		FALSE, 							/* no recurse */
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 2'.].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 0 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 0 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy fetchPointer: 1 ofObject:  callbackBatonOop).

	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 3 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 3 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy fetchPointer: 4 ofObject:  callbackBatonOop).
interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 3'.].
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 6 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 6 ofObject:  callbackBatonOop)).
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 7 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 7 ofObject:  callbackBatonOop)).
	self writeTextToOutputFile: (interpreterProxy arrayValueOf: (interpreterProxy fetchPointer: 8 ofObject:  callbackBatonOop)).
	self writeIntToOutputFile: (interpreterProxy stSizeOf:  (interpreterProxy fetchPointer: 8 ofObject:  callbackBatonOop)).
	callbackBatonOop := nil.	"Reset"
interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: Failed 4'.].
	self writeTextToOutputFile: '#svnInfoForTarget:storeInArray:  Return to squeak...'.
	
	self freeLocalPool: (self cCode: '&localPool').
	^ resultArrayOop! !

!SqueakSVNPlugin methodsFor: 'svn project managing' stamp: 'rt 4/8/2008 23:59'!
svnProject: projectName ExistsOn: aUrl

	| url dirName err revision valueForHash localCtx dirents hashForBaton localPool |
	self export: true.
	self
		var: #url 			declareC: 'char url[STRSIZE]';
		var: #dirName 		declareC: 'char dirName[STRSIZE]';
		var: #err			declareC: 'svn_error_t *err';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #valueForHash	declareC: 'svn_dirent_t *valueForHash';
		var: #localCtx		declareC: 'svn_client_ctx_t *localCtx';
		var: #dirents 		declareC: 'apr_uint32_t dirents'; "we use the baton"
		var: #hashForBaton	declareC: 'apr_hash_t *hashForBaton';
		var: #localPool		declareC: 'apr_pool_t *localPool'.
	self primitive: 'svnProjectExistsOn' parameters: #(Oop Oop).
	
	self writeTextToOutputFile: '#svnProject:ExistsOn: Entered'.
	
	"parse the repository url"
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: url.
	
	(self cCode: 'svn_path_is_url(url)')
		ifFalse: [^ interpreterProxy falseObject].
	
	"parse the name of the project"
	self
		copyOopString: projectName
		toCString: dirName
		ofLength: (self cCode: 'STRSIZE').
	self writeTextToOutputFile: dirName.
	
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	
	"create the baton with the information we need"
	valueForHash := self cCode: 'apr_palloc( localPool , sizeof(svn_dirent_t *) )'.
	self cCode: 'valueForHash->kind = svn_node_none'.
	hashForBaton := self cCode: 'apr_hash_make(localPool)'.
	"store data in baton"
	self cCode: 'apr_hash_set(
		hashForBaton,
		(void*) dirName,
		APR_HASH_KEY_STRING,
		(void*) valueForHash)'.
	
	"find out if the project exists"
	self cCode: 'revision.kind = svn_opt_revision_head'.
	err := self cCode: 'svn_client_list(
		url,
		&revision,
		&revision,
		FALSE,		/*recurse*/
		dirents,		/*memory to store directory information*/
		FALSE,		/*fetch_locks*/
		computeStatusForEntryInBatonWithPathDirentLockAbsPathAndPool, /*callback*/
		(void*) &hashForBaton,
		localCtx, localPool)'.
	err
		ifTrue: [self handleError: err.
				self freeLocalPool: (self cCode: '&localPool').
				^ interpreterProxy falseObject].
	
	"parse data back to something we can interprete and interprete it"
	valueForHash := self cCode: '(svn_dirent_t *) apr_hash_get(
		hashForBaton,
		dirName,
		APR_HASH_KEY_STRING)'.
	(self cCode: 'valueForHash->kind !!= svn_node_dir')
		ifTrue: [self freeLocalPool: (self cCode: '&localPool').
				^ interpreterProxy falseObject].

	self freeLocalPool: (self cCode: '&localPool').
	^ interpreterProxy trueObject! !

!SqueakSVNPlugin methodsFor: 'svn repository requests' stamp: 'rt 4/4/2008 13:00'!
svnRequireAuthenticationAtRepositoryOnUrl: aUrl

	| url boolExists boolNeedsAuth |
	self export: true.
	self
		var: #url				declareC: 'char url[STRSIZE]';
		var: #boolExists			declareC: 'int boolExists';
		var: #boolNeedsAuth	declareC: 'int boolNeedsAuth'.
	self primitive: 'svnRequireAuthenticationAtRepositoryOnUrl' parameters: #(Oop).
	
	self writeTextToOutputFile: '#svnRequireAuthenticationAtRepositoryOnUrl: Entered'.
	self
		copyOopString: aUrl
		toCString: url
		ofLength: (self cCode: 'STRSIZE').
	self
		repositoryAtUrl: url
		Exists: (self cCode: '&boolExists')
		AndNeedsAuthentication: (self cCode: '&boolNeedsAuth').
	boolNeedsAuth ifTrue: [^interpreterProxy trueObject].
	^interpreterProxy falseObject! !

!SqueakSVNPlugin methodsFor: 'svn revert' stamp: 'rt 4/2/2008 17:30'!
svnRevertTargets: targets

	| numberOfTargets copiedTargets arrayPtr aTarget aTargetInPool err localPool localCtx |
	self export: true.
	self
		var: #numberOfTargets declareC: 'int numberOfTargets';
		var: #copiedTargets 		declareC: 'char** copiedTargets';
		var: #arrayPtr 			declareC: 'int* arrayPtr';
		var: #aTarget			declareC: 'char* aTarget';
		var: #aTargetInPool 	declareC: 'char* aTargetInPool';
		var: #err 				declareC: 'svn_error_t *err';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnRevertTargets' parameters: #(Oop).

	self writeTextToOutputFile: '#svnRevertTargets: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	self writeTextToOutputFile: 'Count targets'.
	numberOfTargets := interpreterProxy slotSizeOf: targets.
	
	self writeTextToOutputFile: 'Create apr_array'.
	copiedTargets := self cCode: 'apr_array_make (localPool, numberOfTargets, sizeof (char*))'.

	self writeTextToOutputFile: 'Copy targets'.
	arrayPtr := interpreterProxy firstIndexableField: targets.
	0 to: numberOfTargets-1 do: [:i |
		aTarget := self cStringFromOop: (arrayPtr at: i).
		self writeTextToOutputFile: aTarget.
		aTargetInPool := self cCode: '(char*) apr_pstrdup (localPool, aTarget)'.
		self cCode: 'APR_ARRAY_PUSH (copiedTargets, char*) = aTargetInPool'].
	
	self writeTextToOutputFile: 'Try to revert targets'.
	err := self cCode: 'svn_client_revert (
		copiedTargets,
		FALSE, 	/* no recurse */
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
		
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnRevertTargets: Exit'.
	^ targets! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/4/2008 19:00'!
svnStatusCbBaton: baton target: target status: status
"baton is nil. The array should be stores in callbackBatonOop"

	self returnTypeC: 'void'.
	self
		var: #baton type: 'void *';
		var: #target type: 'const char *';
		var: #status type: 'svn_wc_status2_t *'.
	
	self writeTextToOutputFile: 'svnStatusCbBaton:target:status: entered'.

	interpreterProxy success: (interpreterProxy isArray: callbackBatonOop).
	interpreterProxy failed ifTrue: [self writeTextToOutputFile: 'svnInfoCbBaton:Target:Info:Pool: ERROR: no array...'.].
	
	self
		writeTextToOutputFile: 'Status for target';
		writeIntToOutputFile: (self cCode: 'status->text_status').
	self putStatus: (self cCode: 'status->text_status') in: callbackBatonOop at: 0.! !

!SqueakSVNPlugin methodsFor: 'svn info and status' stamp: 'rkrk 4/3/2008 15:27'!
svnStatusForTarget: targetOop revisionKind: revisionKindOop revisionNumber: revisionNumberOop storeInArray: resultArrayOop

	"This can currently only be used to access the state of the element in the working copy"
	| target err resultRev revision localPool localCtx|
	self export: true.
	self
		var: #target 	 		declareC: 'char target[STRSIZE]';
		var: #err 			declareC: 'svn_error_t *err';
		var: #resultRev 		declareC: 'svn_revnum_t resultRev';
		var: #revision 		declareC: 'svn_opt_revision_t revision';
		var: #localPool		declareC: 'apr_pool_t *localPool';
		var: #localCtx		declareC: 'svn_client_ctx_t *localCtx'.
	self primitive: 'svnStatusForTargetRevisionKindRevisionNumberStoreInArray' parameters: #(Oop Oop Oop Oop).
	
	self writeTextToOutputFile: '#svnStatusForTarget:storeInArray:  Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	"Prepare target string"
	self
		copyOopString: targetOop
		toCString: target
		ofLength: (self cCode: 'STRSIZE').
	
	self
		writeTextToOutputFile: 'svn_client_status2';
		writeTextToOutputFile: target.
	
	"prepare parameters"
	resultRev := -1.
	self cCode: 'revision.kind = svn_opt_revision_unspecified'.
	
	callbackBatonOop := resultArrayOop.
	err := self cCode: 'svn_client_status2 (
		&resultRev, 						/* svn_revnum_t * */
		target,
		&revision,			 			/* const svn_opt_revision_t **/
		svnStatusCbBatontargetstatus, 	/* svn_wc_status_func2_t */
		NULL,							/* status_baton */
		FALSE,							/* recurse */
		TRUE,							/* get_all */
		TRUE, 							/* update, means contact repository for status*/
		TRUE, 							/* no_ignore??? */
		TRUE, 							/* ignore_externals */
		localCtx, localPool)'.
	err ifTrue: [self handleError: err].
	self writeTextToOutputFile: 'svn_client_status2 - end of call'.
	callbackBatonOop := nil.

	self
		writeTextToOutputFile: 'result revision:';
		writeIntToOutputFile: resultRev.
		
	self writeTextToOutputFile: '#svnStatusForTarget:storeInArray:  Return to squeak...'.
	self freeLocalPool: (self cCode: '&localPool').
	^ resultArrayOop! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rt 4/2/2008 17:37'!
svnUpdateTargets: aOopCollectionOfOopTargets toRevisionByNumber: aNumberOop

	| targetsArray squeakStrings count cString revisionNumber localPool localCtx |
	self export: true.
	self 
		var: #squeakStrings 	declareC: 'char** squeakStrings';
		var: #targetsArray 		declareC: 'char** targetsArray';
		var: #cString 			declareC: 'char* cString';
		var: #revisionNumber 	declareC: 'long int revisionNumber';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnUpdateTargetsToRevisionByNumber:' parameters: #(Oop Integer ).
	
	self writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: Entered'.
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	revisionNumber := interpreterProxy integerValueOf: aNumberOop.
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToRevisionByNumber( &localPool, &localCtx, count, targetsArray , revisionNumber )'.

	self cCode: 'free( targetsArray )'.
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnUpdateTargets:toRevisionByNumber: Exit'! !

!SqueakSVNPlugin methodsFor: 'svn update' stamp: 'rt 4/2/2008 17:39'!
svnUpdateTargetsToHeadRevision: aOopCollectionOfOopTargets

	| targetsArray squeakStrings count cString localPool localCtx |
	self export: true.
	self 
		var: #squeakStrings 	declareC: 'char** squeakStrings';
		var: #targetsArray 		declareC: 'char** targetsArray';
		var: #cString 			declareC: 'char* cString';
		var: #localPool			declareC: 'apr_pool_t* localPool';
		var: #localCtx			declareC: 'svn_client_ctx_t* localCtx'.
	self primitive: 'svnUpdateTargetsToHeadRevision' parameters: #(Oop ).
	
	self writeTextToOutputFile: '#svnUpdateTargetsToHeadRevision: Entered'..
	self initialiseLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').
	self authenticateLocalPool: (self cCode: '&localPool') AndLocalContext: (self cCode: '&localCtx').	
	
	"convert the collection"
	squeakStrings := interpreterProxy firstIndexableField: aOopCollectionOfOopTargets.
	count := interpreterProxy slotSizeOf: aOopCollectionOfOopTargets.
	self cCode: 'targetsArray = (char**) malloc(sizeof(char*)*count)'.
	
	"convert the strings"
	0 to: count - 1 do: [:listIndex |
		cString := self cStringAllocatedOnHeapFromOop: (squeakStrings at: listIndex).
		targetsArray at: listIndex put: cString].
	
	"Call SVNWrapper function"
	self cCode: 'updateTargetsToHeadRevision( &localPool, &localCtx, count, targetsArray )'.

	self cCode: 'free( targetsArray )'.
	self freeLocalPool: (self cCode: '&localPool').
	self writeTextToOutputFile: '#svnUpdateTargetsToHeadRevision: Exit'! !

!SqueakSVNPlugin methodsFor: 'helper' stamp: 'rt 4/2/2008 13:40'!
writeToOutputFileText: textOop

	| text |
	self export: true.
	self var: #text declareC: 'char text[STRSIZE]'.
	self primitive: 'writeToOutputFileText' parameters: #(Oop).
	
	self
		copyOopString: textOop
		toCString: text
		ofLength: (self cCode: 'STRSIZE').
		
	self writeTextToOutputFile: text.! !
